<%@ Import Namespace="System.Web" %>
<%@ Import Namespace="System.Drawing" %>
<%@ Import Namespace="System.Security.Cryptography" %>
<%@ Import Namespace="System.Security.Cryptography.X509Certificates" %>

<%@ Import Namespace="Persits.PDF" %>

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>AspPDF.NET Server-Side Digital Signing Demo</title>

<script runat="server" language="c#">
void Page_Load(Object Source, EventArgs E)
{
    txtResult.Text = "";
	
	if( !IsPostBack )
	{
		return;
	}
	
	if( !MyFile.HasFile )
	{
	    txtResult.ForeColor = Color.Red;
	    txtResult.Text = "File not selected.";
	    return;
	}
   
	HttpPostedFile objFile = MyFile.PostedFile;
		
	PdfManager objPdf = new PdfManager();
    
    byte [] FileBytes = new byte[objFile.InputStream.Length];
    objFile.InputStream.Read( FileBytes, 0, FileBytes.Length );
   
    try
    {
        PdfDocument objDoc = objPdf.OpenDocument(FileBytes);

        objPdf.LogonUser( "", "Administrator", "xxxxxx");
        X509Certificate2 objCert = new X509Certificate2( Server.MapPath("democert.pfx"), "test222" );
        
        PdfAnnot objAnnot = objDoc.Sign( objCert, "Persits Software", "For demo purposes only!", "New York, NY", "visible=true;x=10,y=750;width=20;height=20;pageindex=1" );

		// Give the signature the appearance of an image
		PdfImage objImage = objDoc.OpenImage( Server.MapPath( "signature.png" ) );
		PdfGraphics objGraph = objDoc.CreateGraphics( "Left=0; Bottom=0; Right=53; Top=53" );
		objGraph.Canvas.DrawImage( objImage, "x=0; y=0" );
		objAnnot.Graphics[0] = objGraph;

        // We use Session ID for file names.
        // false means "do not overwrite"
        // The method returns generated file name.
        String strPath = Server.MapPath("files") + "\\" + Session.SessionID + ".pdf";
        String strFileName = objDoc.Save(strPath, false);

        txtResult.ForeColor = Color.Black;
        txtResult.Text = "Success. Your signed PDF file <font color=gray>" + strFileName + "</font> can be downloaded <A TARGET=\"_new\" HREF=\"files/" + strFileName + "\"><B>here</B></A>.";              
    }
    catch( Exception e )
    {
    	txtResult.ForeColor = Color.Red;
	    txtResult.Text = e.Message;
	    return;
    }
}


</script>

</head>

<body style="font-family: Arial; font-size: 10pt">

<h3>AspPDF.NET Server-Side Digital Signing Demo</h3>

Upload a PDF document and it will be signed by our certificate.

<p>

<form id="Form1" runat="server" enctype="multipart/form-data" method="POST">

<b>Select a PDF file</b>:<br />

<asp:fileupload Width="300" ID="MyFile" runat="server" /><br/>

<asp:Button ID="upload" Text="Upload for signing" runat="server" />

</p>

<p>

<asp:Label id="txtResult" Font-Bold= "true" runat="server"/>

</p>

</form>

<p>
<b><a href="demo_sign.zip">Download source code (C# and VB.NET) for this demo</a></b>
</p>

</body>
</html>
