<%@ Import Namespace="System.Web" %>
<%@ Import Namespace="System.Drawing" %>
<%@ Import Namespace="System.Security.Cryptography" %>
<%@ Import Namespace="System.Security.Cryptography.X509Certificates" %>

<%@ Import Namespace="Persits.PDF" %>

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>AspPDF.NET Server-Side Digital Signing Demo</title>

<script runat="server" language="vbscript">
Sub Page_Load(Source As Object, E As EventArgs)
    txtResult.Text = ""
	
	If Not IsPostBack Then
		Exit Sub
	End If
	
	
	If Not MyFile.HasFile Then
	    txtResult.ForeColor = Color.Red
	    txtResult.Text = "File not selected."
	    Exit Sub
	End If
   
	Dim objFile As HttpPostedFile = MyFile.PostedFile
		
	Dim objPdf As PdfManager = New PdfManager()
    
    Dim FileBytes(objFile.InputStream.Length ) As Byte
    objFile.InputStream.Read( FileBytes, 0, FileBytes.Length )
   
    Try
        Dim objDoc As PdfDocument = objPdf.OpenDocument(FileBytes)

        objPdf.LogonUser( "", "Administrator", "xxxxxx")
        Dim objCert As X509Certificate2 = New X509Certificate2( Server.MapPath("democert.pfx"), "test222" )
        
        Dim objAnnot as PdfAnnot = objDoc.Sign( objCert, "Persits Software", "For demo purposes only!", "New York, NY", "visible=true;x=10,y=750;width=20;height=20;pageindex=1" )

		' Give the signature the appearance of an image
		Dim objImage As PdfImage = objDoc.OpenImage( Server.MapPath( "signature.png" ) )
		Dim objGraph As PdfGraphics = objDoc.CreateGraphics( "Left=0; Bottom=0; Right=53; Top=53" )
		objGraph.Canvas.DrawImage( objImage, "x=0; y=0" )
		objAnnot.Graphics(0) = objGraph

        ' We use Session ID for file names.
        ' false means "do not overwrite"
        ' The method returns generated file name.
        Dim strPath As String = Server.MapPath("files") + "\\" + Session.SessionID + ".pdf"
        Dim strFileName As String = objDoc.Save(strPath, false)

        txtResult.ForeColor = Color.Black
        txtResult.Text = "Success. Your signed PDF file <font color=gray>" + strFileName + "</font> can be downloaded <A TARGET=""_new"" HREF=""files/" + strFileName + """><B>here</B></A>."
    
	Catch Ex As Exception

    	txtResult.ForeColor = Color.Red
	    txtResult.Text = Ex.Message
	    Exit Sub
    
	End Try
End Sub


</script>

</head>

<body style="font-family: Arial; font-size: 10pt">

<h3>AspPDF.NET Server-Side Digital Signing Demo</h3>

Upload a PDF document and it will be signed by our certificate.

<p>

<form id="Form1" runat="server" enctype="multipart/form-data" method="POST">

<b>Select a PDF file</b>:<br />

<asp:fileupload Width="300" ID="MyFile" runat="server" /><br/>

<asp:Button ID="upload" Text="Upload for signing" runat="server" />

</p>

<p>

<asp:Label id="txtResult" Font-Bold= "true" runat="server"/>

</p>

</form>

<p>
<b><a href="demo_sign.zip">Download source code (C# and VB.NET) for this demo</a></b>
</p>

</body>
</html>
